#!/bin/sh

#set -e

Remove_things(){
    local dir file

    # Reading size of physical memory
    _MEM_TOTAL_KB="$(awk '/^MemTotal: / { print $2 }' /proc/meminfo)"
    _MEM_TOTAL_MB="$(expr ${_MEM_TOTAL_KB} / 1024)"

    # faster shutdown - disabled {{{
    # we don't want this enabled, because shutdown can hungs/slow if there's remaining processes not closed, also we use persistence, we want a healthy shutdown
    #for dir in ${rootmnt}/etc/rc0.d  ${rootmnt}/etc/rc6.d
    #do
        #cd "$dir"
        #rm -f \
            #*915resolution \
            #*aaa-before-all \
            #*acer-* \
            #*alsa-* \
            #*amedyn \
            #*apmd \
            #*bluetooth \
            #*cleantemporalthings \
            #*closestalledprocesses \
            #*cpufrequtils \
            #*cron \
            #*cups \
            #*cupsys \
            #*dbus \
            #*dns* \
            #*drivers-install \
            #*entrance \
            #*esound \
            #*exalt \
            #*fixdevshm \
            #*fixopticaldevices \
            #*fnfxd \
            #*geoloca* \
            #*gpm \
            #*hal \
            #*hdaps* \
            #*hddtemp \
            #*hdparm \
            #*hpoj \
            #*hwclock.sh \
            #*ibm-wclient \
            #*ibmusbasm \
            #*ifupdown \
            #*inetd \
            #*joystickfix \
            #*klogd \
            #*laptop-mode \
            #*loopbackfixer \
            #*makedev \
            #*network-manager \
            #*networking \
            #*openbsd-inetd \
            #*openvpn \
            #*pcmcia \
            #*pommed \
            #*powernowd \
            #*sysklogd \
            #*system-tools-backends \
            #*thermal-daemon \
            #*thermald \
            #*udftools \
            #*urandom \
            #*urfkill \
            #*virtualbox* \
            #*wpa* \
            #*xfs \
            #*xprint \
            #$NULL
    #done

    #cd /

    # }}}

    # put here daemons that are not needed, before to boot the system
    #if ls /sys/bus/pci/drivers/ipw3945 1>/dev/null 2>&1 ; then
    #   true
    #else
    #   echo "ipw3945d" >> ${rootmnt}/tmp/.packages-to-remove
    #   rm -f /etc/init.d/ipw3945d
    #fi

    # Remove some services for low-memory computers {{{
    if [ "$_MEM_TOTAL_MB" -lt "1300" ]; then
        #systemctl disable smbd.service
        rm -f "${rootmnt}/etc/systemd/system/multi-user.target.wants/smbd.service"
    fi

    if [ "$_MEM_TOTAL_MB" -lt "600" ]; then
        rm -f ${rootmnt}/etc/rc*.d/*bluetooth
        rm -f ${rootmnt}/etc/rc*.d/*cups
        rm -f ${rootmnt}/etc/rc*.d/*fail2ban
        rm -f ${rootmnt}/etc/rc*.d/*gpm
        rm -f ${rootmnt}/etc/rc*.d/*samba
        rm -f ${rootmnt}/etc/rc*.d/*sane
        rm -f ${rootmnt}/etc/rc*.d/*smbd

        rm -f ${rootmnt}/usr/bin/bluetooth-applet
        rm -f ${rootmnt}/usr/bin/notify-send
        rm -f ${rootmnt}/usr/sbin/hcid

        # remove from install too
        echo "fail2ban"        >> ${rootmnt}/tmp/.packages-to-remove
        echo "bluetooth"       >> ${rootmnt}/tmp/.packages-to-remove
        echo "bluez-alsa"      >> ${rootmnt}/tmp/.packages-to-remove
        echo "bluez-cups"      >> ${rootmnt}/tmp/.packages-to-remove
        echo "bluez-firmware"  >> ${rootmnt}/tmp/.packages-to-remove
        echo "bluez-utils"     >> ${rootmnt}/tmp/.packages-to-remove
        echo "bluez-utils"     >> ${rootmnt}/tmp/.packages-to-remove
        echo "gnome-bluetooth" >> ${rootmnt}/tmp/.packages-to-remove

        # we don't want to have logs flooding the ram, at least for low memory
        if ! [ -n "${DEBUG}" ] && ! [ -n "${LIVE_DEBUG}" ] ; then
            rm -f ${rootmnt}/etc/rc2.d/*klogd
            rm -f ${rootmnt}/etc/rc2.d/*sysklogd
            rm -f ${rootmnt}/etc/rc2.d/*rsyslog
            rm -f ${rootmnt}/etc/rc2.d/*bootlogd
        fi

    fi

    if [ "$_MEM_TOTAL_MB" -lt "300" ]; then
        rm -f ${rootmnt}/etc/rc*.d/*gpm

        # remove from install too
        echo "gpm" >> ${rootmnt}/tmp/.packages-to-remove
    fi


    # need to disable bluetooth for any reason like blocking boot ?
    if echo "${_CMDLINE}" | grep -Eq "(nobt|nobluetooth)" ; then
        rm -f ${rootmnt}/etc/init.d/bluetooth
        echo "bluetooth"       >> ${rootmnt}/tmp/.packages-to-remove
        echo "bluez-alsa"      >> ${rootmnt}/tmp/.packages-to-remove
        echo "bluez-cups"      >> ${rootmnt}/tmp/.packages-to-remove
        echo "bluez-firmware"  >> ${rootmnt}/tmp/.packages-to-remove
        echo "bluez-utils"     >> ${rootmnt}/tmp/.packages-to-remove
        echo "bluez-utils"     >> ${rootmnt}/tmp/.packages-to-remove
        echo "gnome-bluetooth" >> ${rootmnt}/tmp/.packages-to-remove
    fi

    # }}}
    # disable by default macfanctld unless we are mac
    chmod -x "${rootmnt}/etc/init.d/macfanctld"

}


# vim: set filetype=sh foldmethod=marker :
